<?php
namespace Claromentis\Blog\Comments;

$GLOBALS["__65da1b1e" . "c2d6653e8a" . "0ab7848e53" . "6215"] = (@$GLOBALS["__65da1b1ec2d6653e8a" . "0ab7848e536215"] ?: array()) + array("_0c5123aa744f69bbc0e8b3ea2" . "f6e847d" => base64_decode("bG1zZ" . "w=="), "_48a68e7cee9866c9a733099222c3a" . "b9c" => base64_decode("L2Js" . "b2c="), "_87daa84e346f6" . "420a3f3426e05d" . "16a7b" => base64_decode("Lw" . "=="), "_8dabb06efc95df4cff7c4a" . "fe91857b53" => base64_decode("bmFt" . "ZQ=="), "_f784524629d9404cd" . "62ba9e1475d3bc3" => base64_decode("b2Jq" . "ZWN0" . "X25h" . "bWU="), "_a591754a8ddcdbda9c80f1" . "db4d911e14" => base64_decode("aXNfbnVs" . "bA=="), "_c927258f5322288a992c77b" . "e40ae0b53" => base64_decode("d" . "X" . "J" . "s"), "_2457e28fb4d" . "91b5f7528008" . "953d956b5" => base64_decode("YmxvZy5jb21tb" . "24uYmxvZw=="), "_c7b86566f5" . "835e34c8ef0" . "cf3b36b6046" => base64_decode("L2Jsb" . "2cv"), "_e06da3ffba2e84b8e6" . "f94bd2d6ca3c52" => base64_decode("Y3JlYXRlX2ludGVybm" . "FsX2xpbms="));
use Claromentis\Comments\CommentableInterface;
use Claromentis\Comments\CommentLocationInterface;
use Claromentis\Comments\CommentsRepository;
use Claromentis\Comments\Model\Comment;
use Claromentis\Comments\Notification\Notification;
use Claromentis\Comments\SupportedOptions;
use Claromentis\Comments\Rights;
use Claromentis\Core\Security\SecurityContext;
use BlogPost;
use Claromentis\Core\Services;




class CommentableBlog implements CommentableInterface, CommentLocationInterface
{
    private $blog_id;
    
    
    
    
    private $blog_post;
    
    
    
    
    
    
    public static function CreateFromObject(BlogPost $_d46d6e01a4991a0a517398cada804774)
    {
        $_68ffaaa31e3ba49ed9d6159fbee9f043 = new static();
        $_68ffaaa31e3ba49ed9d6159fbee9f043->blog_post = $_d46d6e01a4991a0a517398cada804774;
        $_68ffaaa31e3ba49ed9d6159fbee9f043->blog_id = $_d46d6e01a4991a0a517398cada804774->GetId();
        return $_68ffaaa31e3ba49ed9d6159fbee9f043;
    }
    public static function DeleteFromObject(BlogPost $_d46d6e01a4991a0a517398cada804774)
    {
        $_5e1e8bdeb7dc6725dab2802927e4f193 = self::CreateFromObject($_d46d6e01a4991a0a517398cada804774);
        
        
        $_d494fa2121915ac5ef3cbbab4c40bef2 = Services::I()->{CommentsRepository::class};
        $_d494fa2121915ac5ef3cbbab4c40bef2->DeleteAllForObject($_5e1e8bdeb7dc6725dab2802927e4f193);
    }
    
    
    
    
    
    
    
    
    
    public function Load($_0ea4e32b57963ac0cb3057e03e9aef64, $_4a033bdf0ce701c6255d5238633ab2d0 = array())
    {
        $this->blog_id = $_0ea4e32b57963ac0cb3057e03e9aef64;
        $this->blog_post = null;
    }
    
    
    
    
    
    
    public function GetAggregationObject()
    {
        if ($GLOBALS["__65da1b1ec2d6653e8a" . "0ab7848e536215"]["_a591754a8ddcdbda9c" . "80f1db4d911e14"]($this->blog_post)) {
            $this->blog_post = new BlogPost($this->blog_id);
        }
        return $this->blog_post;
    }
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    public function UserHasPermission(SecurityContext $context, $_a18f3f2e515f9b634cee4e5fbdcdb572, Comment $_e8d840684607f6c2bbef523090642168 = null)
    {
        
        
        $_d46d6e01a4991a0a517398cada804774 = $this->GetAggregationObject();
        if (!$_d46d6e01a4991a0a517398cada804774->UserHasPermission(PERM_VIEW)) {
            return false;
        }
        if ($_a18f3f2e515f9b634cee4e5fbdcdb572 != Rights::PERM_VIEW && !$_d46d6e01a4991a0a517398cada804774->IsCommentingEnabled()) {
            return false;
        }
        if (($_a18f3f2e515f9b634cee4e5fbdcdb572 & Rights::PERM_EDIT) == Rights::PERM_EDIT || ($_a18f3f2e515f9b634cee4e5fbdcdb572 & Rights::PERM_DELETE) == Rights::PERM_DELETE) {
            if (!$_d46d6e01a4991a0a517398cada804774->UserHasPermission(PERM_APPROVE)) {
                if ($_e8d840684607f6c2bbef523090642168 && (int) $_e8d840684607f6c2bbef523090642168->user_id !== $context->GetUserId()) {
                    return false;
                }
            }
        }
        if ($_e8d840684607f6c2bbef523090642168 && ($_a18f3f2e515f9b634cee4e5fbdcdb572 & Rights::PERM_DELETE) == Rights::PERM_DELETE && $_e8d840684607f6c2bbef523090642168->HasReplies()) {
            return false;
        }
        return true;
    }
    
    
    
    
    
    
    
    public function GetOptions()
    {
        return [SupportedOptions::REPLIES => true, SupportedOptions::LIKES => true, SupportedOptions::ATTACHMENTS => true];
    }
    
    
    
    
    
    
    
    
    
    
    
    
    
    public function Notify(Comment $_e8d840684607f6c2bbef523090642168, Notification $_0dfb4a13f8c551dff0f061eebc847961)
    {
        $_0dfb4a13f8c551dff0f061eebc847961->type = \IMessage::TYPE_BLOG;
        $_d46d6e01a4991a0a517398cada804774 = $this->GetAggregationObject();
        $_0dfb4a13f8c551dff0f061eebc847961->AddTemplateValues([$GLOBALS["__65da1b1e" . "c2d6653e8a" . "0ab7848e53" . "6215"]["_f7845246" . "29d9404cd" . "62ba9e147" . "5d3bc3"] => $_d46d6e01a4991a0a517398cada804774->GetTitle()]);
        $_0dfb4a13f8c551dff0f061eebc847961->Send();
    }
    public function GetBreadcrumbs(int $_2d876b122533fac9677b16ea6c640aa6)
    {
        $_d46d6e01a4991a0a517398cada804774 = $_d46d6e01a4991a0a517398cada804774 = new BlogPost($_2d876b122533fac9677b16ea6c640aa6);
        return [[$GLOBALS["__65da1b1ec2d6653e8a0ab7848e" . "536215"]["_8dabb06efc95df4cff7c4afe9" . "1857b53"] => $GLOBALS["__65da1b1ec2d6653e8a0ab78" . "48e536215"]["_0c5123aa744f69bbc0e8b3" . "ea2f6e847d"]($GLOBALS["__65da1b1ec2d6653e8a0ab784" . "8e536215"]["_2457e28f" . "b4d91b5f7" . "528008953" . "d956b5"]), $GLOBALS["__65da1b1ec2d6653e8a0ab7848" . "e536215"]["_c927258f5" . "322288a992" . "c77be40ae0" . "b53"] => $GLOBALS["__65da1b1e" . "c2d6653e8a" . "0ab7848e53" . "6215"]["_e06da3ffba2e84b8e6f94bd2d6ca3" . "c52"]($GLOBALS["__65da1b1ec2d6653e8a0ab" . "7848e536215"]["_48a68e7cee9866c9a733" . "099222c3ab9c"])], [$GLOBALS["__65da1b1ec2d6653e8a0ab7848e53" . "6215"]["_8dabb06efc" . "95df4cff7c4" . "afe91857b53"] => $_d46d6e01a4991a0a517398cada804774->GetTitle(), $GLOBALS["__65da1b1ec2d6653e8a0ab78" . "48e536215"]["_c927258f5322288a" . "992c77be40ae0b53"] => $GLOBALS["__65da1b1ec2d6653e8" . "a0ab7848e536215"]["_e06da3ffba2e84b8e6f94bd2d6ca" . "3c52"]($GLOBALS["__65da1b1ec2d665" . "3e8a0ab7848e5362" . "15"]["_c7b86566f5835e34c8ef0" . "cf3b36b6046"] . $_d46d6e01a4991a0a517398cada804774->channel_id . $GLOBALS["__65da1b1ec2d6653e8a0ab7848e53" . "6215"]["_87daa84e346f6420a3f3426e05" . "d16a7b"] . $_d46d6e01a4991a0a517398cada804774->id)]];
    }
}